# -*- coding: iso-8859-15 -*-


# Glasnost
# By: Odile Bénassy <obenassy@entrouvert.com>
#     Romain Chantereau <rchantereau@entrouvert.com>
#     Nicolas Clapiès <nclapies@easter-eggs.org>
#     Pierre-Antoine Dejace <padejace@entrouvert.be>
#     Thierry Dulieu <tdulieu@easter-eggs.com>
#     Florent Monnier <monnier@codelutin.com>
#     Cédric Musso <cmusso@easter-eggs.org>
#     Frédéric Péters <fpeters@entrouvert.be>
#     Benjamin Poussin <poussin@codelutin.com>
#     Emmanuel Raviart <eraviart@entrouvert.com>
#     Sébastien Régnier <regnier@codelutin.com>
#     Emmanuel Saracco <esaracco@easter-eggs.com>
#
# Copyright (C) 2000, 2001 Easter-eggs & Emmanuel Raviart
# Copyright (C) 2002 Odile Bénassy, Code Lutin, Thierry Dulieu, Easter-eggs,
#     Entr'ouvert, Frédéric Péters, Benjamin Poussin, Emmanuel Raviart,
#     Emmanuel Saracco & Théridion
# Copyright (C) 2003 Odile Bénassy, Romain Chantereau, Nicolas Clapiès,
#     Code Lutin, Pierre-Antoine Dejace, Thierry Dulieu, Easter-eggs,
#     Entr'ouvert, Florent Monnier, Cédric Musso, Ouvaton, Frédéric Péters,
#     Benjamin Poussin, Rodolphe Quiédeville, Emmanuel Raviart, Sébastien
#     Régnier, Emmanuel Saracco, Théridion & Vecam
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


__doc__ = """Glasnost TAL driver (used for included files)"""

__version__ = '$Revision$'[11:-2]

import marshal
import os
import os.path

import glasnost.common.context as context


compiledFiles = {}

def compilefile(file, mode=None):
    assert mode in ('html', 'xml', None)
    templateDirectoryName = context.getVar('templateDirectoryName')
    file = '%s/%s/%s' % (context.getVar('templatesDirectoryPath'), \
                            templateDirectoryName, file)
    if not os.path.exists(file):
        fallbackPath = context.getVar('fallbackTemplatesDirectoryPath')
        filename = file.split('/')[-1]
        if os.path.exists('%s/default/%s' % (fallbackPath, filename)):
            file = '%s/default/%s' % (fallbackPath, filename)
    language = context.getVar('readLanguages')[0]
    precompiledFileName = '%sc.%s' % (file, language)
    if os.path.exists(precompiledFileName) and \
            os.stat(precompiledFileName)[8] >= os.stat(file)[8]:
        return marshal.load(open(precompiledFileName))

    cacheKey = file + '|' + language
    if compiledFiles.has_key(cacheKey):
        return compiledFiles[cacheKey]
    if mode is None:
        ext = os.path.splitext(file)[1]
        if ext.lower() in (".html", ".htm", ".tal"):
            mode = "html"
        else:
            mode = "xml"
    from glasnost.web.GlasnostTALGenerator import GlasnostTALGenerator
    if mode == "html":
        from TAL.HTMLTALParser import HTMLTALParser
        p = HTMLTALParser(gen = GlasnostTALGenerator(xml=0))
    else:
        from TAL.TALParser import TALParser
        p = TALParser(gen = GlasnostTALGenerator(xml=1))
    p.parseFile(file)
    code = p.getCode()
    compiledFiles[cacheKey] = code
    return code

